# `idcoop user` — user management commands

<!-- toc -->

## `idcoop user add` — create a user

Creates a user but does not set a password for the user. Optionally, the user can be locked.

```
idcoop user add [--locked] <USERNAME>
```
aliases: `idcoop user new`, `idcoop user create`

- `<USERNAME>`: name of the user being added
- `--locked`: specify if the user should be locked when created. Default is to not lock the user.


## `idcoop user delete` — delete a user

Deletes a user entirely from the database.

**WARNING**: Deleting a user makes its name available for re-use, which can be undesirable.
Further, the user won't be deregistered from any applications that use idCoop as their identity provider.
Consider whether this is what you really want before continuing.
[Locking the user may be a better fit in many cases.](#idcoop-user-lock-idcoop-user-unlock--lock-or-unlock-a-user)

```
idcoop user delete <USERNAME>
```
aliases: `idcoop user rm`, `idcoop user remove`, `idcoop user del`

- `<USERNAME>`: name of the user to be deleted


## `idcoop user change-password` — change a user's password

Changes the specified user's password to a new one which is prompted for.

```
idcoop user change-password <USERNAME>
```
aliases: `idcoop user passwd`, `idcoop user chpass`


## `idcoop user lock`, `idcoop user unlock` — lock or unlock a user

Locks or unlocks a user. A locked user cannot log in.

```
idcoop user <lock|unlock> <USERNAME>
```

- `<USERNAME>`: name of the user to be locked or unlocked


## `idcoop user list-all` — list all users

Displays a list of users in tabular form.

```
idcoop user list-all [--usernames]
```
aliases: `idcoop user ls`

- `--usernames`: if specified, only the usernames of users will be shown, one per line.

The output of this command is not considered stable, and should not be used in scripts, unless the `--usernames` option is used.
